CGAL 6.2 - CGAL and the Boost Graph Library

Loading...
Searching...
No Matches
Functions
PLY I/O Functions
Reference Manual » I/O Functions

##

I/O Functions for the Polygon File Format (PLY).

## Functions
template<typename Graph , typename NamedParameters = CGAL::parameters::Default_named_parameters>
bool | CGAL::IO::read_PLY (std::istream &is, Graph &g, std::string &comments, const NamedParameters &np=parameters::default_values())
| reads the graph `g` from the input stream, using the Polygon File Format (PLY).
template<typename Graph , typename NamedParameters = CGAL::parameters::Default_named_parameters>
bool | CGAL::IO::read_PLY (const std::string &fname, Graph &g, std::string &comments, const NamedParameters &np=parameters::default_values())
| reads the graph `g` from a file named `fname`, using the Polygon File Format (PLY).
template<typename Graph , typename NamedParameters = CGAL::parameters::Default_named_parameters>
bool | CGAL::IO::write_PLY (std::ostream &os, const Graph &g, const std::string &comments, const NamedParameters &np=parameters::default_values())
| writes the graph in an output stream, using the Polygon File Format (PLY).
template<typename Graph , typename NamedParameters = CGAL::parameters::Default_named_parameters>
bool | CGAL::IO::write_PLY (const std::string &fname, const Graph &g, const std::string &comments, const NamedParameters &np=parameters::default_values())
| writes the graph in the output file `fname`, using the Polygon File Format (PLY).

## Function Documentation

## ◆ read_PLY() [1/2]

template<typename Graph , typename NamedParameters = CGAL::parameters::Default_named_parameters>

bool CGAL::IO::read_PLY | ( | const std::string & | fname,
|  | Graph & | g,
|  | std::string & | comments,
|  | const NamedParameters & | np = `parameters::default_values()`
| ) |  |

`#include <CGAL/boost/graph/IO/PLY.h>`

reads the graph `g` from a file named `fname`, using the Polygon File Format (PLY).

The data is expected to represent a 2-manifold (possibly with borders).

Template Parameters

  Graph | a model of `MutableFaceGraph`
  NamedParameters | a sequence of Named Parameters

Parameters

  fname | the name of the input file
  g | the graph to be built from the input data
  comments | a string included line by line in the header of the PLY stream (each line will be precedeed by "comment" )
  np | optional Named Parameters described below

Optional Named Parameters

  indicates whether data should be read in binary (`true`) or in ASCII (`false`) Type: Boolean Default: `true` |
  a property map associating points to the vertices of `g` Type: a class model of `WritablePropertyMap` with `boost::graph_traits<Graph>::vertex_descriptor` as key type and `Point_3` as value type Default: `boost::get(CGAL::vertex_point, g)` Extra: If this parameter is omitted, an internal property map for `CGAL::vertex_point_t` must be available in `Graph`. |
  a property map associating to each vertex of `graph` a unique index Type: a class model of `WritablePropertyMap` with `boost::graph_traits<Graph>::vertex_descriptor` as key type and `std::size_t` as value type Default: vertex indices that may exist in the input will be ignored |
  a property map associating colors to the vertices of `g` Type: a class model of `WritablePropertyMap` with `boost::graph_traits<Graph>::vertex_descriptor` as key type and `CGAL::IO::Color` as value type Default: vertex colors that may exist in the input will be ignored |
  a property map associating colors to the faces of `g` Type: a class model of `WritablePropertyMap` with `boost::graph_traits<Graph>::face_descriptor` as key type and `CGAL::IO::Color` as value type Default: face colors that may exist in the input will be ignored |
  whether extra information is printed when an incident occurs during reading Type: Boolean Default: `false` |

Returns
  `true` if reading was successful and the resulting mesh is valid, `false` otherwise.

See also
  Overloads of this function for specific models of the concept `FaceGraph`.

## ◆ read_PLY() [2/2]

template<typename Graph , typename NamedParameters = CGAL::parameters::Default_named_parameters>

bool CGAL::IO::read_PLY | ( | std::istream & | is,
|  | Graph & | g,
|  | std::string & | comments,
|  | const NamedParameters & | np = `parameters::default_values()`
| ) |  |

`#include <CGAL/boost/graph/IO/PLY.h>`

reads the graph `g` from the input stream, using the Polygon File Format (PLY).

The data is expected to represent a 2-manifold (possibly with borders).

Attention
  To read a binary file, the flag `std::ios::binary` must be set during the creation of the `ifstream`.

Template Parameters

  Graph | a model of `MutableFaceGraph`
  NamedParameters | a sequence of Named Parameters

Parameters

  is | the input stream
  g | the graph to be built from the input data
  comments | a string included line by line in the header of the PLY stream (each line will be precedeed by "comment ")
  np | optional Named Parameters described below

Optional Named Parameters

  a property map associating points to the vertices of `g` Type: a class model of `WritablePropertyMap` with `boost::graph_traits<Graph>::vertex_descriptor` as key type and `Point_3` as value type Default: `boost::get(CGAL::vertex_point, g)` Extra: If this parameter is omitted, an internal property map for `CGAL::vertex_point_t` must be available in `Graph`. |
  a property map associating to each vertex of `graph` a unique index Type: a class model of `WritablePropertyMap` with `boost::graph_traits<Graph>::vertex_descriptor` as key type and `std::size_t` as value type Default: vertex indices that may exist in the input will be ignored |
  a property map associating colors to the vertices of `g` Type: a class model of `WritablePropertyMap` with `boost::graph_traits<Graph>::vertex_descriptor` as key type and `CGAL::IO::Color` as value type Default: vertex colors that may exist in the input will be ignored |
  a property map associating colors to the faces of `g` Type: a class model of `WritablePropertyMap` with `boost::graph_traits<Graph>::face_descriptor` as key type and `CGAL::IO::Color` as value type Default: face colors that may exist in the input will be ignored |
  whether extra information is printed when an incident occurs during reading Type: Boolean Default: `false` |

Returns
  `true` if reading was successful and the resulting mesh is valid, `false` otherwise.

See also
  Overloads of this function for specific models of the concept `FaceGraph`.

## ◆ write_PLY() [1/2]

template<typename Graph , typename NamedParameters = CGAL::parameters::Default_named_parameters>

bool CGAL::IO::write_PLY | ( | const std::string & | fname,
|  | const Graph & | g,
|  | const std::string & | comments,
|  | const NamedParameters & | np = `parameters::default_values()`
| ) |  |

`#include <CGAL/boost/graph/IO/PLY.h>`

writes the graph in the output file `fname`, using the Polygon File Format (PLY).

Template Parameters

  Graph | a model of `FaceListGraph`
  NamedParameters | a sequence of Named Parameters

Parameters

  fname | the name of the output file
  g | the graph to be written
  comments | a string included line by line in the header of the PLY stream (each line will be precedeed by "comment ")
  np | optional Named Parameters described below

Optional Named Parameters

  indicates whether data should be written in binary (`true`) or in ASCII (`false`) Type: Boolean Default: `true` |
  a property map associating points to the vertices of `g` Type: a class model of `ReadablePropertyMap` with `boost::graph_traits<Graph>::vertex_descriptor` as key type and `Point_3` as value type Default: `boost::get(CGAL::vertex_point, g)` Extra: If this parameter is omitted, an internal property map for `CGAL::vertex_point_t` must be available in `Graph`. |
  a property map associating normals to the vertices of `g` Type: a class model of `ReadablePropertyMap` with `boost::graph_traits<Graph>::vertex_descriptor` as key type and `Vector_3` as value type Default: `boost::get(CGAL::vertex_point, g)` Extra: If this parameter is omitted, an internal property map for `CGAL::vertex_point_t` must be available in `Graph`. |
  a property map associating to each vertex of `graph` a unique index between `0` and `num_vertices(graph) - 1` Type: a class model of `ReadablePropertyMap` with `boost::graph_traits<Graph>::vertex_descriptor` as key type and `std::size_t` as value type Default: no vertex indices in the output |
  a property map associating colors to the vertices of `g` Type: a class model of `ReadablePropertyMap` with `boost::graph_traits<Graph>::vertex_descriptor` as key type and `CGAL::IO::Color` as value type Default: no vertex color in the output |
  a property map associating colors to the faces of `g` Type: a class model of `ReadablePropertyMap` with `boost::graph_traits<Graph>::face_descriptor` as key type and `CGAL::IO::Color` as value type Default: no face color in the output |
  a parameter used to set the precision (i.e. how many digits are generated) of the output stream Type: int Default: `6` Extra: This parameter is only meaningful while using ASCII encoding. |

Returns
  `true` if writing was successful, `false` otherwise.

## ◆ write_PLY() [2/2]

template<typename Graph , typename NamedParameters = CGAL::parameters::Default_named_parameters>

bool CGAL::IO::write_PLY | ( | std::ostream & | os,
|  | const Graph & | g,
|  | const std::string & | comments,
|  | const NamedParameters & | np = `parameters::default_values()`
| ) |  |

`#include <CGAL/boost/graph/IO/PLY.h>`

writes the graph in an output stream, using the Polygon File Format (PLY).

Attention
  To write to a binary file, the flag `std::ios::binary` must be set during the creation of the `ofstream`, and the `IO::Mode` of the stream must be set to `BINARY`.

Template Parameters

  Graph | a model of `FaceListGraph`
  NamedParameters | a sequence of Named Parameters

Parameters

  os | the output stream
  g | the graph to be written
  comments | a string included line by line in the header of the PLY stream (each line will be precedeed by "comment ")
  np | optional Named Parameters described below

Optional Named Parameters

  a property map associating points to the vertices of `g` Type: a class model of `ReadablePropertyMap` with `boost::graph_traits<Graph>::vertex_descriptor` as key type and `Point_3` as value type Default: `boost::get(CGAL::vertex_point, g)` Extra: If this parameter is omitted, an internal property map for `CGAL::vertex_point_t` must be available in `Graph`. |
  a property map associating normals to the vertices of `g` Type: a class model of `ReadablePropertyMap` with `boost::graph_traits<Graph>::vertex_descriptor` as key type and `Vector_3` as value type Default: `boost::get(CGAL::vertex_point, g)` Extra: If this parameter is omitted, an internal property map for `CGAL::vertex_point_t` must be available in `Graph`. |
  a property map associating to each vertex of `graph` a unique index Type: a class model of `WritablePropertyMap` with `boost::graph_traits<Graph>::vertex_descriptor` as key type and `std::size_t` as value type Default: vertex indices that may exist in the input will be ignored |
  a property map associating colors to the vertices of `g` Type: a class model of `WritablePropertyMap` with `boost::graph_traits<Graph>::vertex_descriptor` as key type and `CGAL::IO::Color` as value type Default: vertex colors that may exist in the input will be ignored |
  a property map associating colors to the faces of `g` Type: a class model of `WritablePropertyMap` with `boost::graph_traits<Graph>::face_descriptor` as key type and `CGAL::IO::Color` as value type Default: face colors that may exist in the input will be ignored |
  a parameter used to set the precision (i.e. how many digits are generated) of the output stream Type: int Default: the precision of the stream `os` Extra: This parameter is only meaningful while using ASCII encoding. |

Returns
  `true` if writing was successful, `false` otherwise.